image: golang:latest

stages:
  - test

.go:
  cache:
    paths:
      - go/pkg/mod
      - go/bin

golangci-lint:
  extends: .go
  stage: test
  script:
    - curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(go env GOPATH)/bin
    - golangci-lint run

go-test:
  extends: .go
  stage: test
  coverage: '/coverage: \d+.\d+% of statements/'
  script:
    - go install gotest.tools/gotestsum@latest
    - go install github.com/boumenot/gocover-cobertura@latest
    - gotestsum --junitfile report.xml --format testname -- -race -cover --coverprofile=coverage.txt -covermode atomic ./...
    - gocover-cobertura < coverage.txt > coverage.xml
  artifacts:
    paths:
      - coverage.xml
      - report.xml
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
      junit: report.xml
